#include <stdio.h>

static double ST[8];

static void Push() { unsigned c;for(c=7; c>0; --c) ST[c] = ST[c-1]; }
static void Pop() { unsigned c;for(c=0; c<7; ++c) ST[c] = ST[c+1]; }

static void LD(double d)   { Push(); ST[0] = d; }
static void STP(double *d) { *d=ST[0]; Pop(); }

static void XCH(unsigned ind) { double d = ST[ind]; ST[ind] = ST[0]; ST[0] = d; }
static void MUL(double d, int pop) { double top = ST[0]; if(!pop)Push(); ST[0] = top * d; }
static void SUBR(double d, int pop) { double top = ST[0]; if(!pop)Push(); ST[0] = top - d; }
static void ADD(double d, int pop) { double top = ST[0]; if(!pop)Push(); ST[0] = top + d; }
static void SUB(double d, int pop){ double top = ST[0]; if(!pop)Push(); ST[0] = d - top; }

int main(void)
{
	unsigned ymax = 24;
	unsigned xmax = 78;
	const double XMin = -2.1;
	const double XMax = +1.1;
	const double YMin = -1.4;
	const double YMax = +1.4;
	
	const double LC7 = XMin;
	const double LC12 = (XMax-XMin)/xmax;
	
	const double LC9 = YMin;
	const double LC11 = (YMax-YMin)/ymax;
	
	const double LC13  = 4.0;
	
	unsigned eax,ebx,ecx,edx;
	
	LD(LC9);
	LD(LC13);
	
	ebx = 0;
	goto L7;
L24:
	XCH(1);
L7:
	LD(LC7);
	edx = 0;
L11:
	LD(ST[0]);
	LD(ST[3]);
	eax = 0;
	goto L12;
L23:
	XCH(1);
	XCH(2);
	XCH(5);
	XCH(6);
	XCH(5);
	MUL(ST[3], 1);
	SUBR(ST[1], 1);
	XCH(1);
	ADD(ST[0], 0);
	XCH(1);
	++eax;
	ADD(ST[2], 0);
	XCH(1);
	ADD(ST[3], 0);
	XCH(3);
	XCH(4);
	XCH(3);
L12:
	LD(ST[1]); // x1 = x0
	LD(ST[1]); // y1 = y0
	XCH(1);
	MUL(ST[0], 0); // x1 *= x0
	XCH(1);
	MUL(ST[0], 0); // y1 *= y0
	if(eax > 63)goto L22;
	LD(ST[1]);
	ADD(ST[1], 0);
	if(ST[0] < 4/*ST[6]*/) goto L23;
L22:
	STP(&ST[0]);
	STP(&ST[0]);
	STP(&ST[0]);
	STP(&ST[0]);
	putchar(96-eax);
	++edx;
	ADD(LC12, 0);  // RP += ra
	if(edx < xmax)goto L11;
	STP(&ST[0]);
	XCH(1);
	ADD(LC11, 0);  // IP += ia
	putchar(10);
	
	++ebx;
	if(ebx < ymax)goto L24;
	STP(&ST[0]);
	STP(&ST[0]);
	
	return 0;
}
